import { DomainEventMessage } from 'cm-schema-event';
import { DomainEventCipher } from './domain-event-cipher';
import { DomainEventCodec } from './domain-event-codec';
import { DomainSchema, Registry } from './domain-schema';
export declare class DomainEvent<T, M> {
    protected codec: DomainEventCodec<Buffer, Buffer>;
    protected schema: DomainSchema<T>;
    protected metadataSchema?: DomainSchema<M>;
    constructor(schema?: string | Record<string, any>, metadataSchema?: string | Record<string, any>, cipher?: DomainEventCipher, disableSchemaRegistry?: Registry | boolean | null);
    encode({ body, correlationId, correlationTopic, eventId, eventType, metadata, timestamp }: DomainEventMessage<T, M>): Promise<Buffer<ArrayBufferLike>>;
    decode(encodedMessage: Buffer): Promise<DomainEventMessage<T, M>>;
    get schemaRegistryId(): string | number;
    get metadataSchemaRegistryId(): string | number;
}
